diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/UnusedRendererRubyglassConduit.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/UnusedRendererRubyglassConduit.java
new file mode 100644
index 000000000..27ca73ba7
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/UnusedRendererRubyglassConduit.java
@@ -0,0 +1,280 @@
+package net.minecraft.client.render.tileentity;
+
+class UnusedRendererRubyglassConduit {
+
+    /*private static final long MAGIC_PRIME_X = 3129871L;
+    private static final long MAGIC_PRIME_Y = 116129781L;
+    private long fastRandomSeed;
+
+    public void doRender(TessellatorGeneral tessellator, TileEntityRubyglassConduit conduitTileEntity, double x, double y, double z, float partialTick) {
+        Player player = Minecraft.getMinecraft().thePlayer;
+
+        if (!shouldRender(conduitTileEntity, player, partialTick))
+            return;
+
+        Side[] openSides = conduitTileEntity.openSides;
+        if (openSides == null || openSides.length == 0)
+            return;
+
+        float powerRatio = conduitTileEntity.powerRatio;
+        int strength = conduitTileEntity.strength;
+
+        // pre-calculate colors and thicknesses so it's not happening every frame
+        final float baseRed = 1.0f;
+        final float baseBlue = 0.04f + (0.2f * powerRatio);
+        final float baseGreen = 0.3f * powerRatio;
+
+        final float innerGreen = Math.min(1.0f, baseGreen + 0.25f);
+        final float innerBlue = Math.min(1.0f, baseBlue + 0.25f);
+        final float coreGreen = Math.min(1.0f, baseGreen + 0.55f);
+        final float coreBlue = Math.min(1.0f, baseBlue + 0.55f);
+
+        final float weakCoreGreen = coreGreen * 0.5f;
+        final float weakCoreBlue = coreBlue * 0.5f;
+
+        final double baseThickness = 0.02 + (0.05 * (powerRatio * powerRatio));
+        final double outerThickness = baseThickness * 3.0;
+        final double innerThickness = baseThickness * 1.5;
+        final double coreThickness = baseThickness * 0.4;
+
+        //for corner joint connections
+        double coreDirectionX = 0;
+        double coreDirectionY = 0;
+        double coreDirectionZ = 0;
+        for (Side side : openSides) {
+            coreDirectionX += side.getOffsetX();
+            coreDirectionY += side.getOffsetY();
+            coreDirectionZ += side.getOffsetZ();
+        }
+
+        setupGL(x, y, z);
+
+        if (conduitTileEntity.worldObj == null) return;
+
+        this.fastRandomSeed = (conduitTileEntity.worldObj.getTotalWorldTime() / 2L)
+            ^ (long) conduitTileEntity.tilePos.x * MAGIC_PRIME_X
+            ^ (long) conduitTileEntity.tilePos.y * MAGIC_PRIME_Y
+            ^ (long) conduitTileEntity.tilePos.z;
+
+        // calculate relative camera position to the block
+        double cameraX = player.x - conduitTileEntity.tilePos.x;
+        double cameraY = (player.y + player.getHeadHeight()) - conduitTileEntity.tilePos.y;
+        double cameraZ = player.z - conduitTileEntity.tilePos.z;
+
+        tessellator.startDrawingQuads();
+        for (Side side : openSides) {
+            renderBeamSide(
+                tessellator, side, cameraX, cameraY, cameraZ, strength,
+                baseRed, baseBlue, baseGreen, innerGreen, innerBlue,
+                coreGreen, coreBlue, weakCoreGreen, weakCoreBlue,
+                outerThickness, innerThickness, coreThickness,
+                coreDirectionX, coreDirectionY, coreDirectionZ
+            );
+        }
+        tessellator.draw();
+
+        releaseGL();
+    }
+
+    private double nextJitterFormula(int strength) {
+        fastRandomSeed = (fastRandomSeed * 25214903917L + 11L) & ((1L << 48) - 1);
+        double baseJitter = (((double) fastRandomSeed / (1L << 48)) - 0.5) * 0.22;
+
+        //calmer when off/weak
+        return strength == 0 ? baseJitter * 0.25 : baseJitter;
+    }
+
+    private boolean shouldRender(TileEntityRubyglassConduit conduitTileEntity, Player player, float partialTick) {
+        if (player == null) return false;
+
+        ItemStack boots = player.inventory.armorItemInSlot(HumanArmorShape.BOOTS);
+        if (boots == null || boots.getItem() != Blocks.BLOCK_RUBYGLASS.asItem())
+            return false;
+
+        return !shouldCull(conduitTileEntity, player, partialTick);
+    }
+
+    private void setupGL(double x, double y, double z) {
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
+        GLRenderer.setShader(Shaders.COLOR);
+        GLRenderer.globalSetLightEnabled(false);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        GLRenderer.setDepthMask(false);
+    }
+
+    private void releaseGL() {
+        GLRenderer.setDepthMask(true);
+        GLRenderer.disableState(State.BLEND);
+        GLRenderer.globalSetLightEnabled(true);
+        GLRenderer.popFrame();
+    }
+
+    private void renderBeamSide(
+        TessellatorGeneral tessellator,
+        Side side, double cameraX, double cameraY, double cameraZ,
+        int strength, float baseRed, float baseBlue, float baseGreen,
+        float innerGreen, float innerBlue, float coreGreen, float coreBlue,
+        float weakCoreGreen, float weakCoreBlue,
+        double outerThickness, double innerThickness, double coreThickness,
+        double coreDirectionX, double coreDirectionY, double coreDirectionZ) {
+
+        double startX = 0.5, startY = 0.5, startZ = 0.5;
+        double endX = 0.5 + (side.getOffsetX() * 0.5);
+        double endY = 0.5 + (side.getOffsetY() * 0.5);
+        double endZ = 0.5 + (side.getOffsetZ() * 0.5);
+
+        int segments = 2;
+        int totalPoints = segments + 1;
+
+        double[] pointX = new double[totalPoints];
+        double[] pointY = new double[totalPoints];
+        double[] pointZ = new double[totalPoints];
+
+        boolean jitterX = side.getOffsetX() == 0;
+        boolean jitterY = side.getOffsetY() == 0;
+        boolean jitterZ = side.getOffsetZ() == 0;
+
+        // calculate coordinate points of the beam
+        pointX[0] = startX;
+        pointY[0] = startY;
+        pointZ[0] = startZ;
+
+        for (int i = 1; i < segments; i++) {
+            double progress = i / (double) segments;
+            pointX[i] = startX + (endX - startX) * progress;
+            pointY[i] = startY + (endY - startY) * progress;
+            pointZ[i] = startZ + (endZ - startZ) * progress;
+
+            if (jitterX) pointX[i] += nextJitterFormula(strength);
+            if (jitterY) pointY[i] += nextJitterFormula(strength);
+            if (jitterZ) pointZ[i] += nextJitterFormula(strength);
+        }
+
+        pointX[segments] = endX;
+        pointY[segments] = endY;
+        pointZ[segments] = endZ;
+
+        double[] rightVectorX = new double[totalPoints];
+        double[] rightVectorY = new double[totalPoints];
+        double[] rightVectorZ = new double[totalPoints];
+
+        for (int i = 0; i < totalPoints; i++) {
+            double directionX, directionY, directionZ;
+
+            //joint connection
+            if (i == 0) {
+                //corners
+                if (coreDirectionX == 0 && coreDirectionY == 0 && coreDirectionZ == 0) {
+                    directionX = side.getOffsetX();
+                    directionY = side.getOffsetY();
+                    directionZ = side.getOffsetZ();
+                } else {
+                    directionX = coreDirectionX;
+                    directionY = coreDirectionY;
+                    directionZ = coreDirectionZ;
+                }
+            } else if (i == totalPoints - 1) {
+                //edge of each block
+                directionX = side.getOffsetX();
+                directionY = side.getOffsetY();
+                directionZ = side.getOffsetZ();
+            } else {
+                //between segments
+                directionX = pointX[i + 1] - pointX[i - 1];
+                directionY = pointY[i + 1] - pointY[i - 1];
+                directionZ = pointZ[i + 1] - pointZ[i - 1];
+            }
+
+            double directionLength = Math.sqrt(directionX * directionX + directionY * directionY + directionZ * directionZ);
+            if (directionLength != 0) {
+                directionX /= directionLength;
+                directionY /= directionLength;
+                directionZ /= directionLength;
+            }
+
+            double toCameraX = cameraX - pointX[i];
+            double toCameraY = cameraY - pointY[i];
+            double toCameraZ = cameraZ - pointZ[i];
+
+            rightVectorX[i] = directionY * toCameraZ - directionZ * toCameraY;
+            rightVectorY[i] = directionZ * toCameraX - directionX * toCameraZ;
+            rightVectorZ[i] = directionX * toCameraY - directionY * toCameraX;
+
+            double rightVectorLength = Math.sqrt(rightVectorX[i] * rightVectorX[i] + rightVectorY[i] * rightVectorY[i] + rightVectorZ[i] * rightVectorZ[i]);
+            if (rightVectorLength != 0) {
+                rightVectorX[i] /= rightVectorLength;
+                rightVectorY[i] /= rightVectorLength;
+                rightVectorZ[i] /= rightVectorLength;
+            } else {
+                rightVectorX[i] = 1;
+                rightVectorY[i] = 0;
+                rightVectorZ[i] = 0;
+            }
+        }
+
+        //draw as continuous "ribbon"
+        if (strength != 0) {
+            tessellator.setColor4f(baseRed, baseGreen, baseBlue, 0.15f);
+            drawRibbonLayer(tessellator, pointX, pointY, pointZ, rightVectorX, rightVectorY, rightVectorZ, outerThickness);
+        }
+
+        tessellator.setColor4f(baseRed, innerGreen, innerBlue, 0.4f);
+        drawRibbonLayer(tessellator, pointX, pointY, pointZ, rightVectorX, rightVectorY, rightVectorZ, innerThickness);
+
+        if (strength != 0) {
+            tessellator.setColor4f(baseRed, coreGreen, coreBlue, 1.0f);
+        } else {
+            tessellator.setColor4f(1.0f, weakCoreGreen, weakCoreBlue, 1.0f);
+        }
+        drawRibbonLayer(tessellator, pointX, pointY, pointZ, rightVectorX, rightVectorY, rightVectorZ, coreThickness);
+    }
+
+    private void drawRibbonLayer(
+    TessellatorGeneral tessellator,
+    double[] pointX, double[] pointY, double[] pointZ,
+    double[] rightVectorX, double[] rightVectorY, double[] rightVectorZ,
+    double thickness) {
+
+        for (int i = 0; i < pointX.length - 1; i++) {
+            int nextIndex = i + 1;
+
+            double currentPointX = pointX[i];
+            double currentPointY = pointY[i];
+            double currentPointZ = pointZ[i];
+
+            double currentRightOffsetX = rightVectorX[i] * thickness;
+            double currentRightOffsetY = rightVectorY[i] * thickness;
+            double currentRightOffsetZ = rightVectorZ[i] * thickness;
+
+            double nextPointX = pointX[nextIndex];
+            double nextPointY = pointY[nextIndex];
+            double nextPointZ = pointZ[nextIndex];
+
+            double nextRightOffsetX = rightVectorX[nextIndex] * thickness;
+            double nextRightOffsetY = rightVectorY[nextIndex] * thickness;
+            double nextRightOffsetZ = rightVectorZ[nextIndex] * thickness;
+
+            tessellator.addVertex(currentPointX + currentRightOffsetX, currentPointY + currentRightOffsetY, currentPointZ + currentRightOffsetZ);
+            tessellator.addVertex(nextPointX + nextRightOffsetX, nextPointY + nextRightOffsetY, nextPointZ + nextRightOffsetZ);
+            tessellator.addVertex(nextPointX - nextRightOffsetX, nextPointY - nextRightOffsetY, nextPointZ - nextRightOffsetZ);
+            tessellator.addVertex(currentPointX - currentRightOffsetX, currentPointY - currentRightOffsetY, currentPointZ - currentRightOffsetZ);
+        }
+    }
+
+    private boolean shouldCull(TileEntityRubyglassConduit conduitTileEntity, Player player, float partialTick) {
+        double deltaX = (conduitTileEntity.tilePos.x + 0.5) - player.x;
+        double deltaY = (conduitTileEntity.tilePos.y + 0.5) - (player.y + player.getHeadHeight());
+        double deltaZ = (conduitTileEntity.tilePos.z + 0.5) - player.z;
+
+        double distanceSquared = deltaX * deltaX + deltaY * deltaY + deltaZ * deltaZ;
+        if (distanceSquared > 100) return true;
+
+        Vector3dc lookVector = player.getViewVector(partialTick);
+        if (lookVector == null) return true;
+
+        double dotProduct = (deltaX * lookVector.x() + deltaY * lookVector.y() + deltaZ * lookVector.z());
+        return dotProduct < 0;
+    }*/
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java b/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
index ce70ed33c..9cabce59c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
+++ b/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
@@ -499,6 +499,7 @@ public class GameWindowGLFW implements GameWindow {
             if (this.glDebugMessageCallback != null) this.glDebugMessageCallback.free();
             this.stbiIconImages.forEach(STBImage::stbi_image_free);
         }
+        GLFW.glfwTerminate();
     }
 
     public static class MonitorInfo {
diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/Colors.java b/game/client/src/main/java/net/minecraft/client/util/helper/Colors.java
index baac5a316..2993e33f2 100644
--- a/game/client/src/main/java/net/minecraft/client/util/helper/Colors.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/Colors.java
@@ -20,6 +20,7 @@ public abstract class Colors {
 	public static final Color[] allFlagColors = new Color[16];
 	public static final Color[] allSignColors = new Color[16];
 	public static final Color[] allRedstoneColors = new Color[16];
+	public static final Color[] allConduitColors = new Color[11];
 	public static final Color[] allPortalColors = new Color[16];
 
 	public static void loadDummyColors() {
@@ -30,6 +31,7 @@ public abstract class Colors {
 		Arrays.fill(allFlagColors, white);
 		Arrays.fill(allSignColors, white);
 		Arrays.fill(allRedstoneColors, white);
+		Arrays.fill(allConduitColors, white);
 		Arrays.fill(allPortalColors, white);
 	}
 
@@ -40,6 +42,7 @@ public abstract class Colors {
 		fillColorArray("/assets/minecraft/textures/misc/colors_lamps.png", allLampColors);
 		fillColorArray("/assets/minecraft/textures/misc/colors_flag.png", allFlagColors);
 		fillColorArray("/assets/minecraft/textures/misc/colors_redstone.png", allRedstoneColors);
+		fillColorArray("/assets/minecraft/textures/misc/colors_conduit.png", allConduitColors);
 		fillColorArray("/assets/minecraft/textures/misc/colors_portal.png", allPortalColors);
 	}
 	
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
index 0d935ae3a..c2bc17f4a 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -8,27 +8,17 @@ import net.minecraft.client.render.worldtype.WorldTypeFXDispatcher;
 import net.minecraft.client.world.chunk.provider.ChunkProviderDynamic;
 import net.minecraft.client.world.chunk.provider.ChunkProviderStatic;
 import net.minecraft.client.world.chunk.provider.ChunkProviderThreadedClient;
-import net.minecraft.client.world.chunk.provider.ChunkProviderViewer;
-import net.minecraft.core.Global;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.chunk.ChunkLoader;
 import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.pos.TilePos;
-import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.save.LevelStorage;
-import net.minecraft.core.world.save.LevelStorageDummy;
-import net.minecraft.core.world.saveddata.SavedDataStorage;
-import net.minecraft.core.world.season.SeasonManager;
 import net.minecraft.core.world.season.Seasons;
 import net.minecraft.core.world.settings.WorldConfiguration;
-import net.minecraft.core.world.type.WorldType;
-import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.core.world.weather.IPrecipitation;
-import net.minecraft.core.world.weather.WeatherManager;
 import net.minecraft.core.world.weather.Weathers;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/Achievement.java b/game/core/src/main/java/net/minecraft/core/achievement/Achievement.java
index 2783692d9..fbddff06b 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/Achievement.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/Achievement.java
@@ -3,6 +3,7 @@ package net.minecraft.core.achievement;
 import net.minecraft.core.achievement.stat.StatDescFormatter;
 import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.item.IItemConvertible;
+import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.collection.NamespaceID;
 
@@ -17,21 +18,20 @@ public class Achievement extends Stat
     private StatDescFormatter statStringFormatter;
     public final int iconItemId;
     private Type type = TYPE_NORMAL;
+    public final ItemStack iconStack;
 
-    public Achievement(NamespaceID id, String name, IItemConvertible icon, Achievement parent)
-    {
-        this(id, name, icon.asItem().id, parent);
-    }
-
-    public Achievement(NamespaceID id, String name, int iconItemId, Achievement parent)
-    {
+    public Achievement(NamespaceID id, String name, ItemStack icon, Achievement parent) {
         super(NamespaceID.fromPool(id.namespace(), "achievement/" + id.value()), "achievement." + name);
-        this.iconItemId = iconItemId;
+        this.iconStack = icon;
+        this.iconItemId = icon.itemID;
         this.description = "achievement." + name;
-
         this.parent = parent;
     }
 
+    public Achievement(NamespaceID id, String name, IItemConvertible icon, Achievement parent) {
+        this(id, name, new ItemStack(icon), parent);
+    }
+
     public Achievement setClientsideAchievement() {
         clientside = true;
         return this;
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java b/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
index e72e72249..1fa32fe63 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.achievement;
 
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.item.ItemBucket;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.util.collection.NamespaceID;
 
@@ -45,7 +46,7 @@ public abstract class Achievements
         new Achievement(NamespaceID.fromPool("minecraft", "bake_cake"), "bakeCake", Items.FOOD_CAKE, BUILD_HOE)
             .registerAchievement();
     public static Achievement CRAFT_ICECREAM =
-        new Achievement(NamespaceID.fromPool("minecraft", "craft_icecream"), "craftIcecream", Items.BUCKET_ICECREAM, BUILD_HOE)
+        new Achievement(NamespaceID.fromPool("minecraft", "craft_icecream"), "craftIcecream", ItemBucket.createItemStack(Items.BUCKET_IRON, ItemBucket.STATE_ICECREAM, 1), BUILD_HOE)
             .registerAchievement();
     public static Achievement CRAFT_PUMPKIN_PIE =
         new Achievement(NamespaceID.fromPool("minecraft", "craft_pumpkin_pie"), "craftPumpkinPie", Items.FOOD_PUMPKIN_PIE, BUILD_HOE)
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
index c273b10ea..46c4fb18b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicActivator.java
@@ -18,6 +18,8 @@ import org.jetbrains.annotations.Nullable;
 import java.util.Objects;
 import java.util.Random;
 
+import static net.minecraft.core.block.BlockLogicRubyglassConduit.packEventConduitData;
+
 public class BlockLogicActivator
     extends BlockLogicVeryRotatable {
     public static final int MASK_POWERED = 0b0000_1000;
@@ -86,6 +88,13 @@ public class BlockLogicActivator
         }
     }
 
+    @Override
+    public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
+        final int meta = world.getBlockData(tilePos);
+        if ((meta & MASK_POWERED) == 0) {return;}
+        world.playBlockEvent(tilePos, LevelListener.EVENT_CONDUIT_SURFACE_PARTICLES, packEventConduitData(null, 10));
+    }
+
     @Override
     public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
         this.useItem(world, tilePos, rand);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
index 0d8bbaf2c..f64634037 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
@@ -181,8 +181,8 @@ public abstract class BlockLogicFluid extends BlockLogic {
         return null;
     }
 
-    protected static void fizz(final @NotNull World world, @NotNull TilePosc tilePos) {
-        world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float) tilePos.x() + 0.5F, (float) tilePos.y() + 0.5F, (float) tilePos.z() + 0.5F, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
+    public static void fizz(final @NotNull World world, @NotNull TilePosc tilePos) {
+        world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float) tilePos.x() + 0.5F, (float) tilePos.y() + 0.5F, (float) tilePos.z() + 0.5F, "random.fizz", 1F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
         for (int i = 0; i < 8; i++) {
             world.spawnParticle("largesmoke", (double) tilePos.x() + Math.random(), (double) tilePos.y() + 1.2D, (double) tilePos.z() + Math.random(), 0.0D, 0.0D, 0.0D, 0, false);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
index 365d71345..01794530b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
@@ -133,4 +133,15 @@ public class BlockLogicLamp extends BlockLogic implements IPainted {
     public void removeDye(@NotNull World world, @NotNull TilePosc tilePos) {
         world.setBlockDataNotify(tilePos, 0);
     }
+
+    @Override
+    public boolean isEquivalent(final @NotNull World world, final @NotNull TilePosc thisPos, final @NotNull TilePosc tilePos) {
+        Block<?> block = world.getBlockType(tilePos);
+
+        if (block.getLogic() instanceof BlockLogicLamp logicOfLamp) {
+            return this.isActive == logicOfLamp.isActive;
+        }
+
+        return false;
+    }
 }
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java
index 39aef4bda..852fcacc4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java
@@ -9,6 +9,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
@@ -18,6 +19,9 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
+import static net.minecraft.core.block.BlockLogicFarmland.isWet;
+import static net.minecraft.core.block.BlockLogicRubyglassConduit.packEventConduitData;
+
 public class BlockLogicMatcher extends BlockLogicAxisAligned {
     public final boolean isActive;
 
@@ -85,11 +89,7 @@ public class BlockLogicMatcher extends BlockLogicAxisAligned {
 
         boolean backMatchesFront;
         Block<?> fBlock = world.getBlockType(front);
-        if (fBlock == null) {
-            backMatchesFront = world.getBlockType(back) == null;
-        } else {
-            backMatchesFront = fBlock.isEquivalent(world, front, back);
-        }
+        backMatchesFront = fBlock.isEquivalent(world, front, back);
 
         if (!this.isActive && backMatchesFront) {
             world.setBlockTypeDataNotify(tilePos, Blocks.MATCHER_ACTIVE, world.getBlockData(tilePos));
@@ -100,33 +100,8 @@ public class BlockLogicMatcher extends BlockLogicAxisAligned {
 
     @Override
     public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
-        if (!this.isActive) {
-            return;
-        }
-
-        final int brightness = 10;
-        double d = 0.0625;
-        for (int i = 0; i < Direction.directions.length; i++) {
-            Direction dir = Direction.directions[i];
-            double px = (double) tilePos.x() + rand.nextFloat();
-            double py = (double) tilePos.y() + rand.nextFloat();
-            double pz = (double) tilePos.z() + rand.nextFloat();
-
-            if (!world.isBlockOpaqueCube(tilePos.add(dir, new TilePos()))) {
-                switch (dir) {
-                    case UP -> py = (tilePos.y() + 1) + d;
-                    case DOWN -> py = (tilePos.y()) - d;
-                    case SOUTH -> pz = (tilePos.z() + 1) + d;
-                    case NORTH -> pz = (tilePos.z()) - d;
-                    case EAST -> px = (tilePos.x() + 1) + d;
-                    case WEST -> px = (tilePos.x()) - d;
-                }
-            }
-
-            if (px < tilePos.x() || px > (tilePos.x() + 1) || py < 0.0D || py > (tilePos.y() + 1) || pz < tilePos.z() || pz > (tilePos.z() + 1)) {
-                world.spawnParticle("reddust", px, py, pz, 0, 0, 0, brightness, false);
-            }
-        }
+        if (!this.isActive) {return;}
+        world.playBlockEvent(tilePos, LevelListener.EVENT_CONDUIT_SURFACE_PARTICLES, packEventConduitData(null, 10));
     }
 
     @Override
